#include "mex.h"
#include "matrix.h"

mxArray* duplicateWithCheck(mxArray* input)
{
	mxArray* output = mxDuplicateArray(input);
	if (!output) {
		mexErrMsgTxt("Out of memory.");
	}
	return output;
}

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray
*prhs[])
{
    unsigned long long *a,*b,*c;
	unsigned long long t;
	size_t ma,na,mb,nb,i,j,k;
	mwSize ndima,ndimb;
    
	ndima = mxGetNumberOfDimensions(prhs[0]);
	ndimb = mxGetNumberOfDimensions(prhs[1]); 
	
	if (ndima > 2 || ndimb > 2) {
		mexErrMsgTxt("Only 2D arrays supportes");
	}
	
	ma = mxGetM(prhs[0]);
	na = mxGetN(prhs[0]);
	mb = mxGetM(prhs[1]);
	nb = mxGetN(prhs[1]);
	
	if (na != mb) {
		mexErrMsgTxt("Dimensions of the matrices do not match");
	}
	
	plhs[0] = mxCreateNumericMatrix(ma,nb,mxUINT64_CLASS,mxREAL);
	
	a = (unsigned long long *) mxGetPr(prhs[0]);
	b = (unsigned long long *) mxGetPr(prhs[1]);
	c = (unsigned long long *) mxGetPr(plhs[0]);
	
	for (i=0;i<ma;++i) {
		for (j=0;j<nb;++j) {
			t = 0;
			for (k=0;k<na;++k) {
				t += a[i + ma*k]*b[k + mb*j];
			}
			c[i + ma*j] = t;
		}
	}

}
