#include "mex.h"
#include "matrix.h"

#define OPERATOR_EQ OPERATOR ## =

mxArray* duplicateWithCheck(mxArray* input)
{
	mxArray* output = mxDuplicateArray(input);
	if (!output) {
		mexErrMsgTxt("Out of memory.");
	}
	return output;
}

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray
*prhs[])
{
    unsigned long long *a,*b,*c;
	int na,nb,i;

	
	a = (unsigned long long *) mxGetData(prhs[0]);
	b = (unsigned long long *) mxGetData(prhs[1]);
    
	na = mxGetNumberOfElements(prhs[0]);
	nb = mxGetNumberOfElements(prhs[1]); 
	
#ifdef CHECK_ZERO
	/* For division and modulus */
	for (i=0;i<nb;++i) {
		if (b[i] == 0) {
			mexErrMsgTxt("Division by zero");
		}
	}
#endif
	
	if (na==nb) {
		plhs[0] = duplicateWithCheck(prhs[0]);
		c = (unsigned long long *) mxGetPr(plhs[0]);
		for (i=0;i<na;++i) {
			#ifdef CHECK_ZERO
				if (b[i] == 0) {
					mexErrMsgTxt("Division by zero");
				}
			#endif
			c[i] OPERATOR_EQ b[i];
		}
	}
	else if (na == 1) {
		plhs[0] = duplicateWithCheck(prhs[1]);
		c = (unsigned long long *) mxGetPr(plhs[0]);
		for (i=0;i<nb;++i) {
			#ifdef CHECK_ZERO
				if (b[i] == 0) {
					mexErrMsgTxt("Division by zero");
				}
			#endif
			c[i] = a[0] OPERATOR b[i];
		}
	}
	else if (nb == 1) {
		#ifdef CHECK_ZERO
			if (b[0] == 0) {
				mexErrMsgTxt("Division by zero");
			}
		#endif
		plhs[0] = duplicateWithCheck(prhs[0]);
		c = (unsigned long long *) mxGetPr(plhs[0]);
		for (i=0;i<na;++i) {
			c[i] = a[i] OPERATOR b[0];
		}
	}
	else {
		mexErrMsgTxt("Arrays must be identical");
	}

}
